<?php
/*
		Plugin Name: PubMan Content 
		Plugin URI: http://colab.mpdl.mpg.de/mediawiki/User:Andi/PubMan_Wordpress_Plugin
		Description: Plugin to fetch contents from PubMan and display it
		Author: Andreas Gros 
		Author URI:http://colab.mpdl.mpg.de/mediawiki/User:Andi
*/

/*  Copyright 2008-2009  Andreas Gros  (email : gros@mpdl.mpg.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


     	if(!class_exists("PubManPlugin"))
				{

				class PubManPlugin 
					{
					//for administration
					var $adminOptionsName = "PubManPluginAdminOptions";
					var $dbTableName = "PubManEntries";
					var $dbVersion = "1.1";
					var $availableCitationStyles = array("APA");
					//for display
					var $defaultNumberOfItemsPerPage = 10;
					var $distanceForTearOffPages = 4;			    // |< < 1 ... 5 6 7 8 9 ... 20 > >|
					var $distanceSurroundingCurrentPage = 2;  //                = 

					var $iconset = array("application/pdf" => "16px-Nuvola_mimetypes_pdf.png",
															 "application/postscript" => "16px-Nuvola_mimetypes_postscript.png",
															 "application/x-latex" => "16px-Nuvola_mimetypes_tex.png",
															 "application/x-tex" => "16px-Nuvola_mimetypes_tex.png",
															 "application/msword" => "16px-Nuvola_mimetypes_wordprocessing.png",
															 "text/plain" => "16px-Nuvola_mimetypes_wordprocessing.png",
															 "default" => "PM_SM_h2_files_locators_16.gif");
					var $const_uncategorized = 1;
					var $totalnumberofrecords;

					//
					// constructor
					//
					function PubManPlugin()
						{ 
						add_action('plugins_loaded', array(&$this, 'init_pubman'));
						
						//
						// Hook for theme coders/hackers
            add_action('pubman_content', array(&$this, 'display_pubmancontent'));

						//
            // Makes it backwards compat pre-2.5 I hope
            if ( function_exists('add_shortcode') ) 
							{
              add_shortcode('pubman-content', array(&$this, 'my_shortcode_handler'));
							}
						$this->getAdminOptions();
						}

					//
					//init: called upon plugin installation + instantiation 
					//
					function init() 
						{
						$this->getAdminOptions();
						}
					
					//	
					//Get/Set the options
					//
					function getAdminOptions()
						{
						//
						//set the default option values
						$pubmanContentAdminOptions = array('baseURLPubMan' => 'http://pubman.mpdl.mpg.de',
																							 'pathItemView' => '/pubman/item/',
																							 'pathSearchAndExport' => '/search/SearchAndExport',
																							 'defaultCitationStyle' => 'APA',
																							 'defaultTextForPublicationLink' => '[pubman]',
																							 'defaultSearchString' => 'escidoc.metadata=sengbusch',
																							 'defaultSortKey' => 'escidoc.issued,,0',
																							 'defaultResearcherName' => 'sengbusch',
																							 'numberOfItemsPerPage' => $this->defaultNumberOfItemsPerPage,
																							 'dbVersion' => $this->dbVersion); 
						//
						//check for previously set option values
						$pubmanOptions = get_option($this->adminOptionsName);
						if(!empty($pubmanOptions))
							{
							foreach($pubmanOptions as $key => $option) {	$pubmanContentAdminOptions[$key] = $option;	}
							}
						update_option($this->adminOptionsName, $pubmanContentAdminOptions);
						return $pubmanContentAdminOptions;
					}

					
					//
					//enable display with correct css settings (add pubman-css) 
					//
					function addHeaderCode() 
						{
						echo '<link type="text/css" rel="stylesheet" href="' . get_bloginfo('wpurl') . '/wp-content/plugins/pubman/css/pubman.css" />';	
						}
					

					//**********************************************************************************************
					//widget and hook specific functions
					//
					function pubman_widget() 
						{
						$pubmanOptions = get_option($this->adminOptionsName);

						echo"<h2>PubMan Content</h2> \n";
						$this->display_pubmancontent(array("searchstring" => $pubmanOptions['defaultSearchString'], 
																							 "citationstyle" => $pubmanOptions['defaultCitationStyle']));
						}
					function init_pubman()
						{
						if ( !function_exists('register_sidebar_widget') ) return;
						register_sidebar_widget("PubMan", "pubman_widget");     
						}

					function my_shortcode_handler($atts, $content=null) 
						{
            return $this->display_pubmancontent($atts);
						}
					
					function inline_replace_callback($matches) 
						{
            if ( ! strlen($matches[1]) ) 
							{ 
              $searchstring = '';
							} 
						else 
							{
              $searchstring = substr($matches[1], 1);  
							}
            return $this->display_pubmancontent($searchstring);
						}
					//**********************************************************************************************




					//**********************************************************************************************
					//helper functions
					//
					//assemble a pubman search&export query string
					//
					function assemblePubmanRequest($searchString, $citationStyle, $sortKeys = '', $startRecord = 1, $maximumNumberOfRecords = -1)
						{
						$pubmanOptions = get_option($this->adminOptionsName);
						$request = $pubmanOptions['baseURLPubMan'] . $pubmanOptions['pathSearchAndExport'];
						$request .= "?cqlQuery=" .  $searchString;
						if(strlen($citationStyle)==0)
							{
							$citationStyle =  $pubmanOptions['defaultCitationStyle']; 
							}
						$request .= "&exportFormat=" . $citationStyle;
						$request .= "&outputFormat=snippet&language=all";
						//check searchstring for sortKey and if it isn't there, add default sortKey
						if((strpos($searchString, "&sortKeys") === false) || (strlen($sortKeys) < 1))
							{
							$request .= "&sortKeys=" . $pubmanOptions['defaultSortKey']; 
							}
						if(strpos($searchString, "&startRecord") === false)
							{
							if ((!is_numeric($startRecord)) || ($startRecord < 1))
								{
								$request .= "&startRecord=1"; 
								}
							else
								{
								$request .= "&startRecord=" . $startRecord;	
								}
							}
						if(strpos($searchString, "&maximumRecords") === false)
							{ 
							if (!is_numeric($maximumNumberOfRecords) || ($maximumNumberOfRecords < 0))
								{
								$request .= "&maximumRecords="; 
								}
							else
								{
								$request .= "&maximumRecords=" . $maximumNumberOfRecords; 
								}
							}
						return $request;
						}


					private function readHeader($ch, $header) 
						{
						global $debug_flag;
						global $tstr;
						if ($debug_flag == 1) { $tstr .= "readHeader=called::"; } 	
						//extracting example data: filename from header field Content-Disposition
						$totalnumberofrecords = $this->extractCustomHeader('x-total-number-of-results:', '', $header);
						if ($totalnumberofrecords) 
							{
							$this->totalnumberofrecords = $totalnumberofrecords;
							}
						return strlen($header);
						}

					private function extractCustomHeader($start,$end,$header) {
						$pattern = '/'. $start .'\s*(\d+)'. $end .'/';
						if (preg_match($pattern, $header, $result)) {
							return intval($result[1]);
						} else {
							return false;
						}
					}
									



					//
					//get content corresponding to $query out of pubman via the search&export interface
					//
					function getPubManContent($query)
						{
						global $state;
						global $publicationdata;
						global $publicationcount;
						global $totalnumberofrecords;
						$totalnumberofrecords = 0;
						$publicationcount = 0;
						unset($publicationdata);
						$publicationdata = array();
						//$snippet = file_get_contents($query);
						
						$curl = curl_init();
						curl_setopt ($curl, CURLOPT_URL, $query);
						curl_setopt ($curl, CURLOPT_HEADER, 0); 
						//Some servers (like Lighttpd) will not process the curl request without this header and will return error code 417 instead. 
						//Apache does not need it, but it is safe to use it there as well.
						curl_setopt($curl, CURLOPT_HTTPHEADER, array("Expect:"));
						
						curl_setopt ($curl, CURLOPT_HEADERFUNCTION, array(&$this,'readHeader'));

						curl_setopt ($curl, CURLOPT_RETURNTRANSFER, 1);

						$header  = curl_getinfo($curl);
						$snippet = curl_exec ($curl);
						curl_close ($curl);

						$state='';
						if (!($xml_parser = xml_parser_create('')))
							die("Couldn't create parser.");
						xml_set_element_handler($xml_parser,"startElementHandler","endElementHandler");
						xml_set_character_data_handler( $xml_parser, "characterDataHandler");

						$retstr = "";
						if(!xml_parse($xml_parser, $snippet)) 
							{
							$retstr = sprintf("XML error: %s at line %d",
												xml_error_string(xml_get_error_code($xml_parser)),
												xml_get_current_line_number($xml_parser));
							}
						xml_parser_free($xml_parser);
						return $retstr;
						}


					//
					//assemble a wordpress post for an escidoc item
					//
					function assemblePost($escidocitem, $citation, $fulltextlink, $mimetype, $visibility)
						{
						$pubmanOptions = get_option($this->adminOptionsName);
						$postContent = str_replace("<br/>", "", $citation);
						$postContent .= "&nbsp;<span class=\"documenttypeandlinks\">";
							
						if(isset($fulltextlink) && !empty($fulltextlink) && isset($visibility) && !empty($visibility) && ($visibility == "public")) 
							{
							$postContent .= "<a href=\"" . $fulltextlink . "\"  title=\"Fulltext link\" >";
							$postContent .=  "<img src=\"" . get_bloginfo('wpurl') . '/wp-content/plugins/pubman/images/';
							if(isset($this->iconset[$mimetype])) 
								{
								$postContent .= $this->iconset[$mimetype];
								}
							else 
								{
								$postContent .= $this->iconset["default"];
								}	
							$postContent .= "\" border=\"0\" alt=\"Doctype\"></a>";
							}
						$postContent .= "&nbsp;<span class=\"escidoclink\"><a href=\"" . $pubmanOptions['baseURLPubMan']  . $pubmanOptions['pathItemView'];
						$postContent .= $escidocitem . "\" title=\"Link to PubMan entry\" >" . $pubmanOptions['defaultTextForPublicationLink'] . "</a></span></span>\n";	
						return $postContent;					
						}


					//
					//get a datetime for WP DB
					//
					function assembleDBDate($thedate)
						{
						$len = strlen($thedate);
						if($len < 10)
							{
							if($len == 7)
								{ //it's possibly yyyy-mm
								$thedate = $thedate . "-01 00:00:00";
								} 
							else if($len == 4)
								{ //it's just a year: yyyy
								$thedate = $thedate . "-01-01 00:00:00";
								} 
							else if(empty($thedate))
								{
								$thedate = "0000-00-00 00:00:00";	
								}
							}	
						else if(strpos($thedate, "T") !== false) 
							{ //it's an ISO date from PubMan
							$thedate = str_replace("T", " ", $thedate);
							$thedate = substr($thedate, 0, strrpos($thedate, "."));
							}	
						return $thedate;
						}

					
					//	
					//get content out of pubman and format it for output
					//
					function display_pubmancontent($atts) 
						{
						global $state;
						global $publicationdata;
						global $publicationcount;
						global $debug_flag;
					  global $tstr;
						$tstr = "";	
						$pubmanOptions = get_option($this->adminOptionsName);
						$itemsPerPage = floatval($pubmanOptions['numberOfItemsPerPage']);
						$citationStyle = '';
						$debug_flag = 0;
						if(is_array($atts))		
							{
							$searchString = $atts['searchstring'];
							if( isset($atts['debug'] ) && ( $atts['debug'] == "1" ) ) { $debug_flag = 1; }
							
							if(utf8_encode(utf8_decode($atts['searchstring']))==$atts['searchstring']) 
								{ //to enable umlauts in the search string, e.g. gemüse
								$searchString		= utf8_decode($atts['searchstring']);
								}
							$citationStyle	= $atts['citationstyle'];
							}
						if(!isset($searchString) || (strlen($searchString) == 0)) 
							{
							$searchString = $pubmanOptions['defaultSearchString']; 
							}
						$pageToDisplay = 1;
						$tpd = 1;
						if(isset($_GET['pd']) && (is_numeric($tpd = $_GET['pd'])) && ($tpd > 0)) 
							{
							$pageToDisplay = intval($tpd);		
							}
						$fromItem = ($pageToDisplay - 1) * $itemsPerPage + 1;
							
						$request = $this->assemblePubmanRequest($searchString, $citationStyle, '', $fromItem, $itemsPerPage);
						$retstr  = $this->getPubManContent($request);
						// the total number of items is now in $this->totalnumberofrecords;
						if(strlen($retstr)==0) 
							{
							$paginatorstr = "";
							$pageToDisplay = 1;
							$numPages = ceil($this->totalnumberofrecords/$itemsPerPage);
							if($numPages > 1) { $showPaginator = 1; }
							else { $showPaginator = 0; }
							
							if($debug_flag == 1) $tstr .= "numPages=" . $numPages . "::totalNumberOfRecords=" . $this->totalnumberofrecords;	

							if ( is_front_page() || is_paged() || is_search() ) { $showPaginator = 0; } //don't show the paginator on the front page (workaround for 
							else 
								{																											//get_posts-on-frontpage-bug of wordpress 2.6
								if(is_category() || is_archive()) //don't show the paginator if the category/archive has subcategories 
									{																//or multiple posts in it
									$mycat = get_cat_id(single_cat_title("", false)); 
									$has_cat_children = (bool)(get_category_children($mycat));
									$posts = get_posts(array('category' => $mycat, 'post_parent' => null) );
									if($has_cat_children || (count($posts) > 1)) { $showPaginator = 0; }
									}
								else 
									{ //there can be multiple posts on a page
									$posts = get_posts(array('post_parent' => get_the_ID()) );
									if((count($posts)>1)) { $showPaginator = 0; }
									}
								}
							if($debug_flag == 1) $tstr .= "showPaginator=" . $showPaginator;	

							//check if paging is needed or has already been started
							if($showPaginator == 1) 
								{
								$tpd = 1;
								if(isset($_GET['pd']) && (is_numeric($tpd = $_GET['pd'])) && ($tpd > 0) && ($tpd <= $numPages)) 
									{
									$pageToDisplay = $tpd;		
									}
								
								$fromItem = 0;
								$toItem = $publicationcount;
								$rURL = $_SERVER['REQUEST_URI'];
								//clear request uri from previous page requests
								if(($ppos = strpos($rURL, "&pd=")) > 0)
									{
									$rURL = substr($rURL, 0, $ppos);
									}
								if(($ppos = strpos($rURL, "?pd=")) > 0)
									{
									$rURL = substr($rURL, 0, $ppos);
									}
								if(strpos($rURL, "?") > 0)	{ $rURL .= "&pd="; }
								else { $rURL .= "?pd="; }
								//assemble the paginator line
								$paginatorstr = "<a href='" . $rURL . "1'>|&lt;</a>&nbsp;";
								$paginatorstr .="<a href='" . $rURL . max(($pageToDisplay - 1), 1) . "'>&lt;</a>&nbsp;&nbsp;&nbsp;";
								if($pageToDisplay == 1) { $paginatorstr .= "<strong>1</strong>&nbsp;"; }
								else {										$paginatorstr .="<a href='" . $rURL . "1'>1</a>&nbsp;"; }
								//check if ... have to be inserted, e.g.
								// |< < 1 ... 5 6 7 8 9 ... 20 > >|
								//                = 
								$paddDots = 0;    
								$pfrom    = 2;
								$pto      = $numPages - 1;                
								if($pageToDisplay - $this->distanceSurroundingCurrentPage - $this->distanceForTearOffPages > 0) 
									{
									$paginatorstr .="<a id='dots'>.&thinsp;.&thinsp;.</a>&nbsp;";	
									if($pageToDisplay + $this->distanceSurroundingCurrentPage + $this->distanceForTearOffPages > $numPages) 
										{
									  $pfrom = max(1, $numPages - $this->distanceSurroundingCurrentPage - $this->distanceForTearOffPages);	 
										}
									else { $pfrom = $pageToDisplay-$this->distanceSurroundingCurrentPage; }
									}
								else { $pto = min(1 + $this->distanceSurroundingCurrentPage + $this->distanceForTearOffPages, $numPages - 1); }	
								
								if($pageToDisplay + $this->distanceSurroundingCurrentPage + $this->distanceForTearOffPages <= $numPages) 
									{
									$pto   = ($pto < $numPages - 1) ? $pto : $pageToDisplay+$this->distanceSurroundingCurrentPage;
									$paddDots = 1;
									}
									
								for($i=$pfrom; $i <= $pto; $i++)
									{
									if($i == $pageToDisplay)
										{
										$paginatorstr .= "<strong>" . $i . "</strong>&nbsp;";
										}
									else 
										{
										$paginatorstr .="<a href='" . $rURL . $i . "'>" . $i . "</a>&nbsp;";
										}	
									}
								if($paddDots == 1){	$paginatorstr .="<a id='dots'>.&thinsp;.&thinsp;.</a>&nbsp;";	}
								
								if($pageToDisplay == $numPages) { $paginatorstr .= "<strong>" . $numPages . "</strong>&nbsp;"; }
								else 
									{
									$paginatorstr .="<a href='" . $rURL . $numPages . "'>" . $numPages . "</a>&nbsp;";
								  }
								$paginatorstr .= "&nbsp;&nbsp;<a href='" . $rURL . min(($pageToDisplay + 1), $numPages) . "'>&gt;</a>&nbsp;";
								$paginatorstr .= "<a href='" . $rURL . $numPages . "'>&gt;|</a>";
								$paginatorstr = "<div class='ppaginator'>" . $paginatorstr . "</div> \n";
								}
							else 
								{ //there are less items than fit on a page
								$fromItem = 0;
								$toItem		= $publicationcount;
								}
							$retstr .= $paginatorstr;	
							for ($i = $fromItem; $i < $toItem; $i++) 
								{	//assemble the text output
								$retstr .= $this->assemblePost(	$publicationdata[$i]["escidocitem"], 
																								$publicationdata[$i]["citation"], 
																								$publicationdata[$i]["fulltextlink"], 
																								$publicationdata[$i]["mime-type"], 
																								$publicationdata[$i]["visibility"]); 
								$retstr .= "<br/><br/>";
								}
							$retstr .= $paginatorstr;
							if(($numPages > 1) && ($showPaginator == 0)) 
								{ //show a "read more ..."-link
								$ppost = get_post(get_the_ID(), ARRAY_A);
								$retstr .= "<div style='width:100%; text-align:right;'><a href='" . $ppost['guid'] . "'>read more ...</a></div>";	
								}
							} 
						if($debug_flag == 1) $retstr .= "::" . $tstr;	
						return $retstr;
						}




				//
				//assemble and show the admin options page
				//
				function printAdminPage() 
					{
          $pubmanOptions = $this->getAdminOptions();

          if (isset($_POST['update_pubmanContentSettings'])) 
						{
            if (isset($_POST['defaultResearcherName'])) 
							{
              $pubmanOptions['defaultResearcherName'] = $_POST['defaultResearcherName'];
							}   
            if (isset($_POST['baseURLPubMan'])) 
							{
              $pubmanOptions['baseURLPubMan'] = $_POST['baseURLPubMan'];
							}   
            if (isset($_POST['pathItemView'])) 
							{
              $pubmanOptions['pathItemView'] = $_POST['pathItemView'];
							}   
            if (isset($_POST['pathSearchAndExport'])) 
							{
              $pubmanOptions['pathSearchAndExport'] = $_POST['pathSearchAndExport'];
							}   
            if (isset($_POST['defaultCitationStyle'])) 
							{
              $pubmanOptions['defaultCitationStyle'] = $_POST['defaultCitationStyle'];
							}   
            if (isset($_POST['defaultTextForPublicationLink'])) 
							{
              $pubmanOptions['defaultTextForPublicationLink'] = $_POST['defaultTextForPublicationLink'];
							}   
            if (isset($_POST['defaultSearchString'])) 
							{
              $pubmanOptions['defaultSearchString'] = $_POST['defaultSearchString'];
							} 
            if (isset($_POST['defaultSortKey'])) 
							{
              $pubmanOptions['defaultSortKey'] = $_POST['defaultSortKey'];
							} 
						if (isset($_POST['numberOfItemsPerPage']) && is_numeric($_POST['numberOfItemsPerPage']) && ($_POST['numberOfItemsPerPage'] > 0)) 
							{
              $pubmanOptions['numberOfItemsPerPage'] = $_POST['numberOfItemsPerPage'];
							}   
						
						update_option($this->adminOptionsName, $pubmanOptions);
           ?>

			 <div class="updated"><p><strong><?php _e("Settings Updated.", "PubMan Content Plugin");?></strong></p></div>

       <?php

					} ?>
      <div class=wrap>
      <form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
      <h2>PubMan Content Plugin</h2>
			<h3>Set the name of the researcher whose publications are to be fetched with this plugin</h3>
			<p><label for="updateDefaultResearcherName"><input type="text" id="defaultResearcherName" name="defaultResearcherName" value="<?php if (strlen($pubmanOptions['defaultResearcherName'])>0) _e($pubmanOptions['defaultResearcherName']); ?>" />Researcher's name, e.g. sengbusch</label><br/></p>


      <h3>Set the base URL for PubMan</h3>
			<p><label for="updateBaseURLPubMan"><input type="text" id="baseURLPubMan" name="baseURLPubMan" value="<?php if (strlen($pubmanOptions['baseURLPubMan'])>0) _e($pubmanOptions['baseURLPubMan']); ?>" /> Base-URL, e.g. http://pubman.mpdl.mpg.de</label><br/></p>
      <h3>Set path to full item view in PubMan</h3>
			<p><label for="updatePathItemView"><input type="text" id="pathItemView" name="pathItemView" value="<?php if (strlen($pubmanOptions['pathItemView'])>0) _e($pubmanOptions['pathItemView']); ?>" /> Item description, e.g. /pubman/item/ </label><br/></p>
      <h3>Set path to the Search&Export interface in PubMan</h3>
			<p><label for="updateSearchAndExport"><input type="text" id="pathSearchAndExport" name="pathSearchAndExport" value="<?php if (strlen($pubmanOptions['pathSearchAndExport'])>0) _e($pubmanOptions['pathSearchAndExport']); ?>" /> Search&amp;Export interface, e.g. /search/SearchAndExport</label><br/></p>
     
		  <h3>Set the default text for the link to the full item view</h3>
			<p><label for="updateDefaultTextForPublicationLink"><input type="text" id="defaultTextForPublicationLink" name="defaultTextForPublicationLink" value="<?php if (strlen($pubmanOptions['defaultTextForPublicationLink'])>0) _e($pubmanOptions['defaultTextForPublicationLink']); ?>" /> Default text, e.g. [LINK]</label><br/></p>
		  <h3>Set the default search string</h3>
			<p><label for="updateDefaultSearchString"><input type="text" id="defaultSearchString" name="defaultSearchString" value="<?php if (strlen($pubmanOptions['defaultSearchString'])>0) _e($pubmanOptions['defaultSearchString']); ?>" /> Default search string</label><br/></p>
			 <h3>Set the default sort key</h3>
			<p><label for="updateDefaultSortKey"><input type="text" id="defaultSortKey" name="defaultSortKey" value="<?php if (strlen($pubmanOptions['defaultSortKey'])>0) _e($pubmanOptions['defaultSortKey']); ?>" /> Default sort key</label><br/></p>
      <h3>Set the numer of items per page</h3>
			<p><label for="updateNumberOfItemsPerPage"><input type="text" id="numberOfItemsPerPage" name="numberOfItemsPerPage" value="<?php  _e($pubmanOptions['numberOfItemsPerPage']); ?>" /> Number of items per page</label><br/></p>
			
			<h3>Set the default citation style</h3>
      <p><label for="defaultCitationStyle_yes"><select id="defaultCitationStyle" name="defaultCitationStyle"><?php 
			foreach($this->availableCitationStyles as $style){
				if($style == $pubmanOptions['defaultCitationStyle']) {$optionstr = '<option selected="selected">';}
				else {$optionstr = "<option>";}
				_e($optionstr . $style . "</option>");
			}
			 ?>
			</select> Available citation styles</label>
       
      <div class="submit">
      <input type="submit" name="update_pubmanContentSettings" value="<?php _e('Update Settings', 'PubManContentPlugin') ?>" /></div>
      </form>
       </div>
<?php
					}//End function printAdminPage()




				//
				//Provide functionality for user for choosing subjects/categories of 
				//publications to show
				//
				function printAdminUsersPage()
					{
					global $state;
					global $publicationdata;
					global $publicationcount;
					global $wpdb;
					global $user_ID;
					
					require_once(ABSPATH . "wp-admin/includes/taxonomy.php");
					require_once(ABSPATH . 'wp-admin/includes/admin.php');
					include_once(ABSPATH . 'wp-includes/post.php');	
					$p_force_update = false;
					$p_report = false;
					
					$pubmanOptions = $this->getAdminOptions();
					$reportstr = "";
					if (isset($_POST['update_pubmanCategorySettings'])) 
						{
						$baseSearchString = "escidoc.any-persons=" . $pubmanOptions['defaultResearcherName'];

						//
						//collect which categories have to be updated
						$categoryListToDisplay = (array)$_POST['p_cat']; 

						//
						//check whether a update is forced (no comparison of local and PubMan timestamps)
						if(isset($_POST['p_forceupdate']) && ($_POST['p_forceupdate'] == "1")) 
							{
							$p_force_update = true;
							}

						//
						//check whether or not to report on the actions taken 
						if(isset($_POST['p_report']) && ($_POST['p_report'] == "1")) 
							{
							$p_report = true;
							}

						//
						//go through the categories to be updated
						foreach($categoryListToDisplay as $tcat) 
							{
							$catID = 0;
							$taxonomy_id = 0;
							if((empty($tcat)) || ($tcat == "No category")) { $tcat = "Uncategorized"; }

							//
							//check if category exists and create category if necessary
							$catID = category_exists($tcat); 
							if((!empty($tcat)) && empty($catID))
								{ 		
								$catID = wp_create_category( $tcat, 0 );
								if($p_report) $reportstr .= "<br/>Category was created: Name: " . $tcat . "; term_id: " . $catID . ".";
								}

							//
							//check if the category was also put into the taxonomy table (for WPMU);
							$sql  = "SELECT term_taxonomy_id from $wpdb->term_taxonomy";
							$sql .= " LEFT JOIN $wpdb->terms ON ($wpdb->term_taxonomy.term_id = $wpdb->terms.term_id)";
							$sql .= " WHERE $wpdb->terms.name= %s";	
							$taxonomy_id = $wpdb->get_var($wpdb->prepare($sql, $tcat));
							if(empty($taxonomy_id)) 
								{
								$reportstr .= "<br/><span style=\"color:blue\">ERROR: Category creation incomplete!</span>";	
								}
							if($p_report) $reportstr .= "<br/>Using category: " . $tcat . "; term_id: " . $catID . ".";
							
							//
							//get the posts that are already in this category in wordpress 
							//and populate this category if necessary
							if(!empty($catID))
								{
								$postsql = "SELECT $wpdb->posts.* FROM $wpdb->posts";
								$postsql .= " LEFT JOIN $wpdb->postmeta ON($wpdb->posts.ID = $wpdb->postmeta.post_id)";
								$postsql .= " LEFT JOIN $wpdb->term_relationships ON($wpdb->posts.ID = $wpdb->term_relationships.object_id)";
								$postsql .= " LEFT JOIN $wpdb->term_taxonomy ON($wpdb->term_relationships.term_taxonomy_id = $wpdb->term_taxonomy.term_taxonomy_id)";
								$postsql .= " WHERE $wpdb->term_taxonomy.term_id = " . $catID;
								$postsql .= " AND $wpdb->term_taxonomy.taxonomy = 'category'";
								$postsql .= " AND $wpdb->posts.post_status = 'publish'";
								$postsql .= " ORDER BY $wpdb->postmeta.meta_value ASC";
								
								//
								//get the wordpress records
								$wp_records = $wpdb->get_results($postsql, ARRAY_A);
								
								//
								//get the corresponding pubman records
								$searchString = $baseSearchString;
								if($catID != 1) 
									{ 
									$searchString .=  "%20AND%20escidoc.subject=%22" . str_replace(" ", "%20", $tcat) . "%22";
									}
								$request = $this->assemblePubmanRequest($searchString, '', '', 1, -1);
								$retstr  = $this->getPubManContent($request);

								//
								//if searches were successful, check whether posts need to be updated
								if(empty($retstr) && ($publicationcount > 0))
									{

									//
									//collect post identifier (escidoc post titles, e.g. escidoc54321) for presence/absence checking
									if(isset($wp_objids)) { unset($wp_objids); }
									$wp_objids = array();
									if(!empty($wp_records))
									foreach($wp_records as $record) { $wp_objids[] = $record['post_title']; }
									
									//
									//walk through publications returned from PubMan/eSciDoc
									for($i = 0; $i < $publicationcount; $i++)
										{
										$pitem = $publicationdata[$i];
										if(($catID != $this->const_uncategorized ) || (($catID == $this->const_uncategorized) && (empty($pitem["subject"]))))
											{
											
											//
											//find corresponding item in wp_list
											$eobjid = $pitem['escidocitem'];
											$pos = array_search($eobjid, $wp_objids);
											
											//
											//Sanitize the dates and prepare for the fact that there could be 
											//items that were never published, but talks held at conferences or unpublished manuscripts
											$last_modified = $this->assembleDBDate( $pitem['last-modification-date'] );
											if( !empty( $pitem['date-issued'] ) )
												{
												$date_issued   = $this->assembleDBDate( $pitem['date-issued'] );
												}
											else
												{
												if ( !empty( $pitem['start-date'] ) )
													{
													$date_issued   = $this->assembleDBDate( $pitem['start-date'] );
													}
												else
													{
													$date_issued   = $this->assembleDBDate( $pitem['created'] );
													}
												}

											if($pos !== false)
												{

												//
												//item is already in WP,
												//check if update is forced and compare the last-modified time stamps if necessary
												if($p_force_update || (strtotime($wp_records[$pos]['post_modified']) < ($plastmod = strtotime($last_modified))) )
													{
													$postModified = date("Y-m-d H:i:s", $plastmod);
													$postContent = $this->assemblePost($pitem["escidocitem"], $pitem["citation"], $pitem["fulltextlink"], $pitem["mime-type"], $pitem["visibility"]);
													$sql = "UPDATE $wpdb->posts SET post_content='$postContent', post_date='$date_issued', post_date_gmt='$date_issued', post_modified='$postModified', post_modified_gmt='$postModified' WHERE $wpdb->posts.ID = " . $wp_records[$pos]['ID'];
													$wpdb->query($sql);
													if($p_report) $reportstr .= "<br/>Post " . $wp_records[$pos]['post_name'] . " updated.";
													}
												}
											else 
												{ 
												
												//
												//item was not found in this category
												//check if it is a new item that needs to be inserted, or if it is an existing item 
												//that just has to be added to another category			
												//post_title equals $pitem["escidocitem"] as it contains the colon, e.g. escidoc:37112; 
												//post_name does not contain the colon as it becomes sanitized by wordpress during post creation								 
												$pid = $wpdb->get_var( $wpdb->prepare( "SELECT id FROM $wpdb->posts WHERE post_title = %s", $pitem["escidocitem"] ) );

												if(empty($pid))
													{ 
													
													//
													//there is really no such item in WP, so we create it
													if($p_report) $reportstr .= "<br/>Insert new post " . $pitem["escidocitem"] . " in category nr " . $catID;
														
													$postarr = array(
														'post_author' =>  __(	$user_ID ), 
														'post_date' => $date_issued, 
														'post_date_gmt' => $date_issued,
														'post_content' => stripslashes( $this->assemblePost($pitem["escidocitem"], $pitem["citation"], $pitem["fulltextlink"], $pitem["mime-type"], $pitem["visibility"] ) ), 
														'post_title' => __(	$pitem["escidocitem"] ),
														'post_category' => array( $catID ), //is is important that key "post_category" gets an array as value
														'post_name' => __( $pitem["escidocitem"] ),
														'post_modified' => $last_modified,
														'post_modified_gmt' => $last_modified,
														'post_status'  => __( 'publish' ),
														'post_type' => __( 'post' ),
														'comment_status' => __( 'open' ),
														'ping_status' => __( 'open' )
													);
														
													$pid = wp_insert_post($postarr, true);
													if ( empty($pid) || is_wp_error($pid) )
														{
														$reportstr .= $pid->get_error_message();
														$reportstr.="<br/><span style=\"color:red\">ERROR: Post could not be created for " . $pitem["escidocitem"] . "</span>";
														}
													else 
														{

														//
														//add the item to the list of known objects	
														$wp_objids[] = $pitem["escidocitem"]; 
														}

													}//if(empty($pid))
												else 
													{

													//
													//the post exists already, but has to be added to this category
													$tcats = wp_get_post_categories($pid);
													if($p_report) $reportstr .= "<br/>Post id :" . $pid . ": " . $pitem["escidocitem"] . " had categories: " . implode(", ", $tcats) . "; add it to category nr " . $catID;
													$tcats[] =  $catID;
													wp_set_post_categories($pid, $tcats);
													}
												}//end item did not exist
											}//end if(($tcat != "Uncategorized") || (($tcat == "Uncategorized") && (empty($pitem["subject"]))))					
										}//end for($i = 0; $i < $publicationcount; $i++)		

									//
									//Finish by updating the category cache
									update_category_cache();
									wp_cache_flush();
									}//end if (empty($retstr) && ($publicationcount >= count($wp_records)))
								else 
									{
									$reportstr .= "<br/><span style=\"color:red\">ERROR: With this searchstring: $request<br/> PubMan returned no items. The parser returned: $retstr .</span>";
									}	

								}//end if(!empty($catID))

							}//end foreach($categoryListToDisplay as $tcat) 

						}//end if (isset($_POST['update_pubmanCategorySettings'])) 



					//
					//Show the category/post management page for the WP user
					//collect the categories/subjects the researcher has worked on
					$categoryList = array();
					$researcherName = $pubmanOptions['defaultResearcherName'];
					$searchString = "escidoc.any-persons=" . $researcherName;
						
					$request = $this->assemblePubmanRequest($searchString, '', '', 1, -1);
					$retstr  = $this->getPubManContent($request);
					if(empty($retstr)) {//everything is o.k.

						//collect the subjects that should be displayed
						for ($i = 0; $i < $publicationcount; $i++) 
							{	//assemble the text output 
							$cats = explode(",", $publicationdata[$i]["subject"]);
							foreach($cats as $cat) 
								{ 
								if(!empty($cat)) 
									{
									$cat = trim($cat);
									if (($cat != strtoupper($cat)) && (strpos($cat, " ") === false))
										{
										$cat = ucfirst(strtolower(trim($cat)));
										}
									$categoryList[] = $cat; 
									}
								else 
									{
									$categoryList[] = "Uncategorized"; 
									}
								}
							}
						$categoryListUnique = array_unique($categoryList); 
						$categoryCounts = array_count_values($categoryList);
						$catListCount = array(); 

						foreach($categoryListUnique as $cat)
							{
							$catListCount[] = array('name' => $cat, 'post_count' => $categoryCounts[$cat], 'wp_cat_id' => category_exists($cat) );	
							}

						//print the options	
						echo	"<div class=\"wrap\">";
						echo "<h2>PubMan Content Plugin</h2> \n";

						echo "<form method=\"post\" action=\"" . $_SERVER["REQUEST_URI"] . "\"> \n";
						
						wp_nonce_field('update-options');

						$retstr = "Category (Number of items)<br/> \n";
						foreach($catListCount as $cat)
							{
							$retstr .= "<input type=\"checkbox\" ";
							if(!empty($cat['wp_cat_id'])) { $retstr .= "checked "; }
							$retstr .= "name=\"p_cat[]\" value=\"" . $cat['name'] . "\"/> ";
							$retstr .= $cat['name'] . " (" . $cat['post_count'] . ")<br/> \n";
							}
						$retstr .= "<hr/><br/>Management and output options<br/><br/><input type=\"checkbox\" name=\"p_forceupdate\" value=\"1\" /> Force update (all posts get updated from PubMan. <span style=\"color:red\">Attention: all local changes will be lost!</span>)<br/>";
						$retstr .= "<input type=\"checkbox\" name=\"p_report\" value=\"1\" /> Show a report about the actions taken<br/>";
						echo $retstr;
					?>	
						<input type="hidden" name="update_pubmanCategorySettings" value="update" />
						<input type="hidden" name="action" value="update" />

						<p class="submit">
						<input type="submit" name="Submit" value="<?php _e('Save Changes') ?>" />
						</p>
						</form>
						</div>
					
					<?php	
					if($p_report){ echo "<hr/><br/>Action Report:<br/>";	}
					else if ($reportstr != ''){ echo "<hr/><br/>Error Report:<br/>";	}
					echo $reportstr;
						}//end if(strlen($retstr)==0)
					else 
						{
						//
						// there was an error message	
						echo $retstr;	
						}
					}//end printAdminUsersOptions
				
				}//end class 	

			}//end if !class exists



	//
	// crate the pubman plugin
	//
	if(class_exists("PubManPlugin"))
		{
		$pubmanPlugin = new PubManPlugin();	
		}

	//
	//Initialize the admin panel
	//
	if (!function_exists("PubManContentPlugin_ap")) 
		{
		function PubManContentPlugin_ap() 
			{
			global $pubmanPlugin;
			if (!isset($pubmanPlugin)) 
				{
				return;
				}
			if (function_exists('add_options_page')) 
				{
				add_options_page('PubMan Content Plugin', 'PubMan Content Plugin Config', 9, basename(__FILE__), array(&$pubmanPlugin, 'printAdminPage'));
				}

			if (function_exists('add_submenu_page')) 
				{
				add_submenu_page('edit.php', "PubMan Content User Options","PubMan Content User Options", 0, basename(__FILE__), array(&$pubmanPlugin, 'printAdminUsersPage'));
				}
			
			}	
		}


	//
	//add the wordpress hook actions
	//
	if (isset($pubmanPlugin)) 
		{
		//Actions
		add_action('admin_menu', 'PubManContentPlugin_ap');
		add_action('activate_pubman/pubman_plugin.php',  array(&$pubmanPlugin, 'init'));
		add_action('wp_head', array(&$pubmanPlugin, 'addHeaderCode'), 1);
		}





//**********************************************************************************************************************
//support functions for parsing xml (depends on expat)
//
//
function startElementHandler ($parser,$name,$attrib)
	{
	global $state;
	global $publicationdata;
	global $publicationcount;

	switch ($name) 
		{
		case $name=="DCTERMS:BIBLIOGRAPHICCITATION" : 
			{
			$state = "citation";
			$publicationdata[$publicationcount]["citation"] = "";
			$publicationdata[$publicationcount]["fulltextlink"] = "";
			$publicationdata[$publicationcount]["mime-type"] = "";
			$publicationdata[$publicationcount]["subject"] = "";
			$publicationdata[$publicationcount]["visibility"] = "";
			$publicationdata[$publicationcount]["date-issued"] = "";
			$publicationdata[$publicationcount]["start-date"] = "";
			$publicationdata[$publicationcount]["created"] = "";
			break;
			}
		case $name=="ESCIDOCITEM:ITEM" : 
			{
			$publicationdata[$publicationcount]["escidocitem"] = $attrib['OBJID'];
			$publicationdata[$publicationcount]["last-modification-date"] = $attrib['LAST-MODIFICATION-DATE'];
			break;
			}
		case $name=="PROP:MIME-TYPE" : 
			{
			$state = "mime-type";
			break;
			}
		case $name=="PROP:VISIBILITY" : 
			{
			$state = "visibility";
			break;
			}
		case $name=="DC:SUBJECT" :	
			{
			$state = "subject";
			break;
			}
		case $name=="DCTERMS:ISSUED" : 
			{
			$state = "date-issued";
			break;
			}
		case $name=="ESCIDOC:START-DATE" : 
			{
			$state = "start-date";
			break;
			}
		case $name=="DCTERMS:CREATED" : 
			{
			$state = "created";
			break;
			}
		case $name=="ESCIDOCCOMPONENTS:CONTENT" : 
			{
			$publicationdata[$publicationcount]["fulltextlink"] = $attrib['XLINK:HREF'];
			break;
			}
		}
	}
	
function endElementHandler ($parser,$name)
	{
	global $publicationcount;
	global $state;
	$state='';
	if($name=="ESCIDOCITEM:ITEM") {$publicationcount++;}
	}

function characterDataHandler ($parser, $data) 
	{
	global $publicationdata;
	global $publicationcount;
	global $state;
	if (!$state) {return;}
	if ($state=="citation") { $publicationdata[$publicationcount]["citation"] = $data;}
	if ($state=="mime-type") { $publicationdata[$publicationcount]["mime-type"] = $data;}
	if ($state=="subject") { $publicationdata[$publicationcount]["subject"] = $data;}
	if ($state=="date-issued") { $publicationdata[$publicationcount]["date-issued"] = $data;}
	if ($state=="start-date") { $publicationdata[$publicationcount]["start-date"] = $data;}
	if ($state=="visibility") { $publicationdata[$publicationcount]["visibility"] = $data;}
	if ($state=="created") { $publicationdata[$publicationcount]["created"] = $data;}
	}
			
?>
